#ifndef ONDEVICEIMAGEEMBEDDINGENGINE_H
#define ONDEVICEIMAGEEMBEDDINGENGINE_H

#include <kylin-ai/ai-engine/ondeviceembeddingengine.h>

class ImageEmbeddingServer;
namespace ai_engine::embedding {

class OndeviceImageEmbeddingEngine
    : public AbstractOnDeviceImageEmbeddingEngine {
public:
    OndeviceImageEmbeddingEngine();
    ~OndeviceImageEmbeddingEngine();
    std::string engineName() const override { return "ondevice"; }
    std::string currentModelName() const override {return "text embedding"; }

    void embeddingTextAsync(const std::string& input,
                            EmbeddingResultCallback callback) override;
    void embeddingImageFromImageFileAsync(
        const std::string& file_path,
        EmbeddingResultCallback callback) override;
    void embeddingImageFromBase64ImageDataAsync(
        const std::string& file_data,
        EmbeddingResultCallback callback) override;

private:
    ImageEmbeddingServer* imageembeddingserver_ = nullptr;
};

}  // namespace ai_engine::tm::embedding

#endif
